#ifndef __POWERD_H__
#define __POWERD_H__

#include <glib-object.h>

G_BEGIN_DECLS

namespace {

#define POWERD_TYPE_SOURCE            (powerd_source_get_type ())
#define POWERD_SOURCE(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), POWERD_TYPE_SOURCE, PowerdSource))
#define POWERD_IS_SOURCE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POWERD_TYPE_SOURCE))
#define POWERD_SOURCE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), POWERD_TYPE_SOURCE, PowerdSourceClass))
#define POWERD_IS_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POWERD_TYPE_SOURCE))
#define POWERD_SOURCE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), POWERD_TYPE_SOURCE, PowerdSourceClass))

typedef struct _PowerdSource         PowerdSource;
typedef struct _PowerdSourceClass    PowerdSourceClass;
typedef struct _PowerdSourcePrivate  PowerdSourcePrivate;

struct _PowerdSourceClass {
	GObjectClass parent_class;
};

// XXX - this should be in the C file
struct _PowerdSourcePrivate {
    GDBusConnection * session;
    gchar * path;
    ComCanonicalPowerd * skel;
};

struct _PowerdSource {
	GObject parent;
	PowerdSourcePrivate * priv;
};

GType                    powerd_source_get_type          (void);
}

G_END_DECLS

#endif
